=== debian/changelog ===
cpuinfo (0.0~git20230113.6481e8b-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sun, 31 Dec 2023 17:09:47 -0500

cpuinfo (0.0~git20230113.6481e8b-1) experimental; urgency=medium

  * New upstream version 0.0~git20230113.6481e8b
    Please pin to this snapshot for PyTorch/v2.1.X release.
  * Quilt refresh patchset.
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Thu, 28 Dec 2023 14:44:52 -0500
