## cpuinfo 0.0~git20240830.fa1c679

=== debian/changelog ===
cpuinfo (0.0~git20240830.fa1c679-5) unstable; urgency=medium

  * Team upload.
  * d/test: remove non-existent cpuinfo-dump, add names to tests
  * d/patches: remove useless disable-auxv-dump-on-arm.patch

 -- Shengqi Chen <harry-chen@outlook.com>  Sat, 14 Sep 2024 22:45:47 +0800

cpuinfo (0.0~git20240830.fa1c679-4) unstable; urgency=medium

  * Team upload.
  * d/symbols: add one new symbol on arm platforms
  * d/lintian-overrides: add arch-dependent tags
  * d/patches: backport upstream patch to fix bug on non-SVE arm hardware

 -- Shengqi Chen <harry-chen@outlook.com>  Thu, 12 Sep 2024 22:13:07 +0800

cpuinfo (0.0~git20240830.fa1c679-3) unstable; urgency=medium

  * Team upload.
  * d/patches: update patch to fix FTBTS on unsupported platforms
  * d/tests: run cpuinfo-dump on ARM platforms
  * d/patches: add patch to remove auxv-dump on ARM platforms

 -- Shengqi Chen <harry-chen@outlook.com>  Thu, 05 Sep 2024 14:30:20 +0800

cpuinfo (0.0~git20240830.fa1c679-2) unstable; urgency=medium

  * d/control: compile cpuinfo on riscv64
  * d/tests: only run tests on their supported architectures
  * d/rules: allow dh_auto_test to fail, remove relative patch
  * d/patches: add patch to fix FTBTS on some officially-unsupported
    platforms

 -- Shengqi Chen <harry-chen@outlook.com>  Wed, 04 Sep 2024 17:56:47 +0800

cpuinfo (0.0~git20240830.fa1c679-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.0~git20240830.fa1c679
    Please use this version for PyTorch/v2.4.x
  * d/patches: refresh existing patches, fix Forwarded header
  * d/control: bump std-ver to 4.7.0.1 (no changes required)

 -- Shengqi Chen <harry-chen@outlook.com>  Tue, 03 Sep 2024 00:47:13 +0800

cpuinfo (0.0~git20231104.d6860c4-1~exp1) experimental; urgency=medium

  * New upstream version 0.0~git20231104.d6860c4
    + Please pin to this snapshot for PyTorch/v2.3.X
  * Rebase and refresh existing patches.
  * Deprecate clog following upstream.
  * Refresh symbols control file.
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Thu, 11 Jul 2024 00:54:38 -0400
