=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: science
 Homepage: https://github.com/pytorch/cpuinfo
 Priority: optional
-Standards-Version: 4.6.0.1
+Standards-Version: 4.7.0.1
 Vcs-Git: https://salsa.debian.org/deeplearning-team/cpuinfo.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/cpuinfo
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
@@ -11,7 +11,7 @@
 Rules-Requires-Root: no
 
 Package: cpuinfo
-Architecture: amd64 arm64 armel armhf i386 x32
+Architecture: amd64 arm64 armel armhf i386 x32 riscv64
 Multi-Arch: no
 Depends: libcpuinfo0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: CPU INFOrmation library (binary utilities)
