## cpuinfo 0.0~git20250110.8a1772a

=== debian/changelog ===
cpuinfo (0.0~git20250110.8a1772a-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.0~git20250110.8a1772a
    Please use this version for PyTorch/v2.6+ release
  * d/patches: remove patches applied by upstream
  * d/control: use correct std-ver 4.7.0
  * Switch cmake backend to ninja
  * Fix incorrect architectures in cpuinfo.lintian-overrides

 -- Shengqi Chen <harry@debian.org>  Thu, 23 Jan 2025 17:00:28 +0800
