=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Section: science
 Homepage: https://github.com/pytorch/cpuinfo
 Priority: optional
-Standards-Version: 4.7.0.1
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/deeplearning-team/cpuinfo.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/cpuinfo
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
 Uploaders: Mo Zhou <lumin@debian.org>
-Build-Depends: cmake, debhelper-compat (= 13), googletest
+Build-Depends: cmake, debhelper-compat (= 13), googletest, ninja-build
 Rules-Requires-Root: no
 
 Package: cpuinfo
