## cpuinfo 0.0~git20250203.aaac07e

=== debian/changelog ===
cpuinfo (0.0~git20250203.aaac07e-1) unstable; urgency=medium

  * New upstream version 0.0~git20250203.aaac07e
  * d/control: add myself in uploaders

 -- Shengqi Chen <harry@debian.org>  Wed, 12 Feb 2025 23:38:33 +0800
