=== debian/changelog ===
cpuinfo (0.0~git20250327.39ea79a-1) unstable; urgency=medium

  * New upstream version 0.0~git20250327.39ea79a.

 -- Shengqi Chen <harry@debian.org>  Thu, 10 Apr 2025 13:54:37 +0800
