=== debian/changelog ===
cpuinfo (0.0~git20250905.877328f-1) unstable; urgency=medium

  [ Kentaro Hayashi ]
  * Use d/watch 5.

  [ Shengqi Chen ]
  * New upstream version 0.0~git20250905.877328f.
  * d/control: bump std-ver to 4.7.2 (no changes required).
  * d/patches: refresh existing patches.

 -- Shengqi Chen <harry@debian.org>  Fri, 24 Oct 2025 17:45:38 +0800
